program dm;
  uses CFH, Machine;
  const Month: packed array [0..11] of string[3] =
	       ('Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun',
		'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec');
  var ec: ExitCode;
      FNB: F_N_Buffer;
      MInfo: ModInfo;
      errtxt,
      fname: string;
      mods, segs: boolean;
      f: file;

  procedure HelpScreen;
  begin
  writeln;
  writeln('Usage: dm filename [-ms]');
  writeln(' -m  print used modules');
  writeln(' -s  print segment names');
  end; { HelpScreen }

  procedure ParseParameters;
    var i: Natural;
	wrk: string;

  procedure UpCaseStr(var s: string);
    var l: byte;
  begin
  for l:= 1 to length(s) do s[l]:= UpCase(s[l]);
  end; { UpCaseStr }

  begin
  i:= ParamCount;
  while i > 0 do
    begin Dec(i);
    wrk:= ParamStr(ParamCount - i);
    if not (wrk[1] in ['-', '/']) and (wrk <> '?')
      then if FName <> ''
	     then begin write(' *** Specify only one filename!');
		  HelpScreen;
		  end
	     else FName:= wrk
      else begin if wrk[1] in ['-', '/'] then delete(wrk, 1, 1);
	   if wrk = ''
	     then begin write(' *** No option specified after -');
		  HelpScreen;
		  end;
	   UpCaseStr(wrk);
	   if wrk[1] = '?' then HelpScreen;
	   while wrk <> '' do
	     begin
	     if wrk[1] = 'M'
	       then mods:= true
	       else if wrk[1] = 'S'
		 then segs:= true
	       else begin write(' *** Invalid option <', wrk[1], '> ***');
		    HelpScreen; halt;
		    end;
	     delete(wrk, 1, 1);
	     end;
	   end;
    end; { while }
  if FName <> ''
    then if FName[length(FName)] = '.'
	   then Dec(FName[0])
	   else FName:= FName + '.pgm';
  end; { ParseParameters }

begin
writeln('Dump Modules. Version[0.10]. (c) 1989 YGP.');
mods:= false; segs:= false; fname:= '';
ParseParameters;
if fname = '' then begin HelpScreen; halt; end;

writeln('File: ', fname);
Assign(f, fname);
writeln('Module version     Date        Time   Used');
GetFirstMod(f, FNB, MInfo, ec);
repeat
  if ec <> OK
    then begin GetText(ec, errtxt);
	 write(errtxt, '!'#7);
	 end
    else with MInfo do
	   begin write(name, version: 6);
	   if Date.Year < 1989
	     then write('  No Date    ')
	     else write(Date.day: 4, '.',
			Month[Date.month], '.',
			Date.Year);
	   if Time.Hours = 24
	     then write('  No Time ')
	     else write(Time.Hours: 4, ':',
			Time.minutes:2, ':',
			Time.seconds:2);
	   write(FNB.CurrMD.Nextrnl: 5);
	   if FNB.CurrMD.Nextrnl > 0 then
	     if mods
	       then write('-m ???': 10); { unimplemented }
	   if FNB.CurrMD.MainSeg <> 0 then
	     if segs
	       then write('-s ???': 10); { unimplemented }
	   end; { MInfo }
  writeln;
  GetNextMod(FNB, MInfo, ec);
until ec = NoMore;

end. { dm }
